; Startup for the #amycoders 384 bytes demo compo by Blueberry/Efreet.

;       include lvo/exec_lib.i
;       include lvo/intuition_lib.i
;       include lvo/graphics_lib.i
;       include lvo/dos_lib.i
;       include intuition/screens.i
;       include dos/dostags.i

        include dh1:s_aga12/384BytesCompo/systemdefs.i

call    macro
        jsr     _LVO\1(a6)
        endm
        

        section code,code

Startup:
        move.l  $4.w,a6
        lea.l   IntName(pc),a1
        moveq.l #0,d0
        call    OpenLibrary
        move.l  d0,IntBase
        beq.w   .noint
        lea.l   GfxName(pc),a1
        moveq.l #0,d0
        call    OpenLibrary
        move.l  d0,GfxBase
        beq.w   .nogfx
        lea.l   DosName(pc),a1
        moveq.l #0,d0
        call    OpenLibrary
        move.l  d0,DosBase
        beq.w   .nodos

        ; Open screen.
        move.l  IntBase(pc),a6
        suba.l  a0,a0
        lea.l   ScreenParams(pc),a1
        call    OpenScreenTagList
        move.l  d0,_Screen
        beq.b   .noscr
        ; Ensure that the screen is interleaved.
        move.l  d0,a0
        move.l  sc_RastPort+rp_BitMap(a0),a1
        move.l  bm_Planes+4(a1),d1
        sub.l   bm_Planes(a1),d1
        cmp.w   bm_BytesPerRow(a1),d1
        bgt.b   .notil
        ; Put BitMap1 into _Screen->ViewPort.RasInfo
        move.l  sc_ViewPort+vp_RasInfo(a0),a1
        move.l  #BitMap1,ri_BitMap(a1)

        ; Set own priority to 0.
        move.l  $4.w,a6
        suba.l  a1,a1
        call    FindTask
        move.l  d0,a1
        moveq.l #0,d0
        call    SetTaskPri

        ; Create VBlank process.
        move.l  DosBase(pc),a6
        move.l  #ProcessParams,d1
        call    CreateNewProc
        move.l  d0,Process
        beq.b   .nopro

        bsr.w   DoTheJob

.nopro:
.notil: move.l  IntBase(pc),a6
        move.l  _Screen(pc),a0
        call    CloseScreen
.noscr: move.l  $4.w,a6
        move.l  DosBase(pc),a1
        call    CloseLibrary
.nodos: move.l  GfxBase(pc),a1
        call    CloseLibrary
.nogfx: move.l  IntBase(pc),a1
        call    CloseLibrary
.noint: moveq.l #0,d0
        rts

ScreenParams:
        dc.l    SA_Left, 0
        dc.l    SA_Top, 0
        dc.l    SA_Width, 320
        dc.l    SA_Height, 256
        dc.l    SA_Depth, 8
        dc.l    SA_ShowTitle, 0
        dc.l    SA_BitMap, BitMap1
        dc.l    SA_Quiet, 1
        dc.l    SA_Type, CUSTOMSCREEN
        dc.l    SA_DisplayID, PAL_MONITOR_ID
        dc.l    SA_Interleaved, 1
        dc.l    TAG_END

ProcessParams:
        dc.l    NP_Entry,VBlankProcess
        dc.l    NP_Name,ProcessName
        dc.l    NP_Priority,1

BitMap1:
        dc.w    8*40,256,8,0
        dc.l    Planes1+0*40,Planes1+1*40,Planes1+2*40,Planes1+3*40
        dc.l    Planes1+4*40,Planes1+5*40,Planes1+6*40,Planes1+7*40

BitMap2:
        dc.w    8*40,256,8,0
        dc.l    Planes2+0*40,Planes2+1*40,Planes2+2*40,Planes2+3*40
        dc.l    Planes2+4*40,Planes2+5*40,Planes2+6*40,Planes2+7*40

IntBase:        dc.l    0
GfxBase:        dc.l    0
DosBase:        dc.l    0
_Screen:        dc.l    0
OldBitMap:      dc.l    0
Process:        dc.l    0
OldStack:       dc.l    0
ProcessState:   dc.w    0
C2P1x1State:    dc.w    0
C2P2x1State:    dc.w    0
C2PEdgeState:   dc.w    0

IntName:        dc.b    'intuition.library',0
GfxName:        dc.b    'graphics.library',0
DosName:        dc.b    'dos.library',0
ProcessName:    dc.b    'VBlank process',0
                even

;; ******************** Calling shell ********************

DoTheJob:
        move.l  a7,OldStack
        move.w  #$000f,$dff096
        bsr.w   Init
        movem.l d0-a6,Registers
        move.w  #1,ProcessState
.wait1: cmp.w   #2,ProcessState ; Wait for VBlank process to begin.
        bne.b   .wait1
        bsr.w   Main

Exit:
        move.w  #$000f,$dff096
        move.l  OldStack(pc),a7
        move.w  #3,ProcessState
.wait2: cmp.w   #4,ProcessState ; Wait for VBlank process to end.
        bne.b   .wait2
        rts

VBlankProcess:
.loop1: move.l  GfxBase(pc),a6
        call    WaitTOF
        tst.w   ProcessState(pc)
        beq.b   .loop1
        move.w  #2,ProcessState
        movem.l Registers,d0-a6
.loop2: bsr.w   VBlank
        movem.l d0-d1/a0-a1/a6,-(a7)
        move.l  GfxBase(pc),a6
        call    WaitTOF
        movem.l (a7)+,d0-d1/a0-a1/a6
        cmp.w   #3,ProcessState
        bne.b   .loop2
        move.w  #4,ProcessState
        rts

;; ******************** Internal routines ********************

TestMouse:
        ; Exit if LMB pressed.
        btst.b  #6,$bfe001
        beq.b   Exit
        rts

GetScreen:
        move.l  _Screen(pc),a3
        move.l  sc_ViewPort+vp_RasInfo(a3),a3
        move.l  #BitMap1,a2
        add.l   #BitMap2,a2
        sub.l   ri_BitMap(a3),a2        ; Other BitMap.
        move.l  bm_Planes(a2),a1
        ; A1 = PlanePtr of Undisplayed BitMap
        ; A2 = Undisplayed BitMap
        ; A3 = _Screen->Viewport.RasInfo
        rts

DoubleBuffer:
        bsr.w   GetScreen
        move.l  a2,ri_BitMap(a3)        ; Do the switch.
        move.l  GfxBase(pc),a6
        move.l  _Screen(pc),a0
        lea.l   sc_ViewPort(a0),a0
        call    ScrollVPort             ; And display it.
        rts

ClearEdges:
        tst.w   C2PEdgeState
        beq.b   .ok
        bsr.w   GetScreen
        move.w  #256*8-1,d7
.loop:  clr.l   (a1)+
        lea.l   40-8(a1),a1
        clr.l   (a1)+
        dbf     d7,.loop
        clr.w   C2PEdgeState
.ok:    rts

        ; *** Adjust this include path! ***
        include dh1:s_aga12/384BytesCompo/C2P1x1x8.S
        include dh1:s_aga12/384BytesCompo/C2P2x1x8.S

;; ******************** Callable routines ********************

Update128x128:
        ; Update the screen in 2x2 resolution
        ; using the supplied 128x128 linear chunky buffer.
        ; The sides will get color 0.
        ; Callable from Init and Main.
        ; Input: A0 = Chunky buffer
        bsr.w   TestMouse
        movem.l d0-a6,-(a7)
        bsr.w   ClearEdges
        tst.w   C2P2x1State(pc)
        blt.b   .ok
        move.w  #128,d0
        move.w  #128,d1
        moveq.l #40,d2
        move.w  #8+15*40,d3
        bsr.w   C2P2x1x8\.SetSizes
        move.w  #-1,C2P2x1State
        move.l  8*4(a7),a0
.ok:    bsr.w   GetScreen
        addq.l  #4,a1
        bsr.w   C2P2x1x8
        move.l  8*4(a7),a0
        bsr.w   GetScreen
        lea.l   8*40+4(a1),a1
        bsr.w   C2P2x1x8
        bsr.w   DoubleBuffer
        movem.l (a7)+,d0-a6
        rts

Update160x128:
        ; Update the screen in 2x2 resolution
        ; using the supplied 160x128 linear chunky buffer.
        ; Callable from Init and Main.
        ; Input: A0 = Chunky buffer
        bsr.w   TestMouse
        movem.l d0-a6,-(a7)
        move.w  #-1,C2PEdgeState
        tst.w   C2P2x1State(pc)
        bgt.b   .ok
        move.w  #160,d0
        move.w  #128,d1
        moveq.l #40,d2
        move.w  #15*40,d3
        bsr.w   C2P2x1x8\.SetSizes
        move.w  #1,C2P2x1State
        move.l  8*4(a7),a0
.ok:    bsr.w   GetScreen
        bsr.w   C2P2x1x8
        move.l  8*4(a7),a0
        bsr.w   GetScreen
        lea.l   8*40(a1),a1
        bsr.w   C2P2x1x8
        bsr.w   DoubleBuffer
        movem.l (a7)+,d0-a6
        rts

Update256x256:
        ; Update the screen in 1x1 resolution
        ; using the supplied 256x256 linear chunky buffer.
        ; The sides will get color 0.
        ; Callable from Init and Main.
        ; Input: A0 = Chunky buffer
        bsr.w   TestMouse
        movem.l d0-a6,-(a7)
        bsr.w   ClearEdges
        tst.w   C2P1x1State(pc)
        blt.b   .ok
        move.w  #256,d0
        move.w  #256,d1
        moveq.l #40,d2
        move.w  #8+7*40,d3
        bsr.w   C2P1x1x8\.SetSizes
        move.w  #-1,C2P1x1State
        move.l  8*4(a7),a0
.ok:    bsr.w   GetScreen
        addq.l  #4,a1
        lea.l   TempBuffer,a2
        bsr.w   C2P1x1x8
        bsr.w   DoubleBuffer
        movem.l (a7)+,d0-a6
        rts

Update320x256:
        ; Update the screen in 1x1 resolution
        ; using the supplied 320x256 linear chunky buffer.
        ; Callable from Init and Main.
        ; Input: A0 = Chunky buffer
        bsr.w   TestMouse
        movem.l d0-a6,-(a7)
        move.w  #-1,C2PEdgeState
        tst.w   C2P1x1State(pc)
        bgt.b   .ok
        move.w  #320,d0
        move.w  #256,d1
        moveq.l #40,d2
        move.w  #7*40,d3
        bsr.w   C2P1x1x8\.SetSizes
        move.w  #1,C2P1x1State
        move.l  8*4(a7),a0
.ok:    bsr.w   GetScreen
        lea.l   TempBuffer,a2
        bsr.w   C2P1x1x8
        bsr.w   DoubleBuffer
        movem.l (a7)+,d0-a6
        rts

CacheClear:
        ; Clear caches so written SMC will be valid.
        ; Callable from Init, VBlank and Main.
        movem.l d0-d1/a0-a1/a6,-(a7)
        move.l  $4.w,a6
        call    CacheClearU
        movem.l (a7)+,d0-d1/a0-a1/a6
        rts

SetPalette:
        ; Set the screen palette to the one supplied.
        ; Format is 256 longwords in $xxrrggbb.
        ; The upper byte of each longword is ignored.
        ; Callable from Init, VBlank and Main.
        ; Input: A0 = Palette
        movem.l d0-d2/a0-a2/a6,-(a7)
        lea.l   .data(pc),a1
        lea.l   4(a1),a2
        move.w  #256-1,d2
.loop:  move.w  (a0)+,d0
        move.b  d0,(a2)
        addq.l  #4,a2
        move.b  (a0)+,d0
        move.b  d0,(a2)
        addq.l  #4,a2
        move.b  (a0)+,d0
        move.b  d0,(a2)
        addq.l  #4,a2
        subq.b  #1,d2
        bne.b   .loop

        move.l  GfxBase(pc),a6
        move.l  _Screen(pc),a0
        lea.l   sc_ViewPort(a0),a0
        call    LoadRGB32
        movem.l (a7)+,d0-d2/a0-a2/a6
        rts
.data:
        dc.w    256,0
        dcb.l   256*3
        dc.w    0

;; ******************** Your code here ********************
;;
;; 512 byte demo by azure..
;;
;; no comments - just dirty quick code.
;;

Code_Start:

Init:   ; Called once in the beginning.
        ; Registers are undefined.

        lea     buffer,a6
        move.l  a6,a0
        move.l  a6,a1

************* Create Palette


        moveq   #0,d0
.lop1
        move.w  d0,d7
        mulu    d7,d7
        lsr.w   #8,d7
        move.w  d7,d6
        mulu    d6,d6
        lsr.w   #8,d6
        lsr     d6
        move.b  d6,-(a0)
        move.b  d7,-(a0)
        move.w  d0,-(a0)

        subq.b  #1,d0
        bne.s   .lop1           
        
        bsr.w   SetPalette
        
        moveq   #-1,d7
************ Calculate sinus-table (d0.l=0, d7.w=$ffff)        
;possible to gain some bytes here..

        move.l  #50000000,d1   ;b=d

        lsr.w   #7,d7
.slop1
        move.l  d0,-(a1)       
        add.l   d1,d0          
        move.l  d0,d2           
        muls.l  #-2587328,d3:d2 
        add.l   d3,d1          
        dbf     d7,.slop1

        lea     tex,a2
.ilop
        rol.l   d3,d3
        add     d7,d3
        move.b  d3,d0
        lsr.b   #2,d0
        add.b   -250(a2),d0
        mulu.w  #6,d2
        add.w   d0,d2
        lsr.w   #3,d2
        move.b  d2,(a2)+
        dbf     d7,.ilop
.llop
        
        move.w  d7,d0
        eor.w   #$8080,d0
        move.w  d0,d1
        ext.w   d0
        asr.w   #8,d1
        muls.w  d0,d0
        muls.w  d1,d1
        add.l   d1,d0
        lsr.l   #6,d0
        addq    #1,d0
        not.b   d0
        btst    #8,d0
        beq.s   .eeeee
        moveq   #0,d0
.eeeee  
        move.b  d0,(a2)+        
        dbf     d7,.llop        

        lsr.w   #5-3,d7
.lololo
        add     d7,d3
        ror.l   d3,d3
        move    d3,d4
        asr.w   #4,d4
        move.w  d4,(a2)+                
        dbf     d7,.lololo              
        
VBlank: ; Called every vblank after Init has finished.
        addq.b  #1,-1(a6)
        addq.w  #1,-4(a6)
        rts
                                                                                                                               
Main:   ; Called once when Init has finished.
        ; Registers are as left by Init.
        ; If it terminates, the demo will exit.

        move.l  a6,a0
        bsr     Update256x256

        cmp.w   #10*50,-4(a6)
        blt.w   bump

        moveq   #0,d2
.lop1
        move.b  (a0),d2
        subq.w  #6,d2
        bpl.s   .ok3
        moveq   #0,d2
.ok3
        move.b  d2,(a0)+
        dbf     d7,.lop1                
        moveq   #0,d2
        
ROTit:
        lsr.w   #5,d7
        move.w  -2(a6),d0
        lea     -512*4(a6),a3   
        move    (a3,d0.w*4),d5
        add.w   #64*4,a3
        move    (a3,d0.w*4),d6
        lea     pts,a0
        move.l  a0,a2
.lop1
        movem.w (a0),d0/d1/d2
        add.w   #16,a0
        move    d0,d3
        move    d2,d4
        muls    d6,d0   ;cos 1
        muls    d6,d2   ;cos 2
        muls    d5,d3   ;sin 1
        muls    d5,d4   ;sin 2
        sub.l   d4,d0
        add.l   d3,d2

        moveq   #15,d3
        asr.l   d3,d2
        lsl.l   d3,d1
        
        add     #8*500,d2
        moveq   #1,d3
        or      d3,d2
.perlop:
        asr.l   #7,d0
        divs.w  d2,d0
        add     #128,d0
        cmp     #256-4,d0
        bcc.s   .out    
        exg.l   d0,d1
        subq.b  #1,d3
        bpl.s   .perlop
        
        and.l   d3,d1
        lsl.w   #8,d1
        move.b  d0,d1
        addq.l  #1,d3
        move.w  #$c0c0,d4
        
        moveq   #2,d0
.pomo   
        move.w  (a6,d1.l),d2
        and.w   d4,d2
        eor.w   d4,d2
        lsr.w   #2,d2
        add.w   d2,(a6,d1.l)
                
        add     d3,d1
        subq    #1,d0
        bpl.s   .pomo
.out
        dbf     d7,.lop1

        move.w  -4(a6),d3
        cmp.w   #20*50,d3
        blt.w   main

        neg     d3
        add     #((20*50)<<0)+1800,d3
        bpl.s   .yepp
        moveq   #0,d3   
.yepp
        move    d3,a3   
                
        lsr.w   #5,d7
.polop
        movem.w (a2),d0/d1/d2/d3/d4/d5
        
        add.w   d4,d0
        add.w   d5,d2
        
        add.w   d3,d1
        addq    #1,d3           ;gravity force 
        
        cmp     #1800,d1
        blt.s   .nono
        moveq   #11,d0
        
        move.w  d6,d3
        lsr.w   #8,d3
        lsr.w   #1,d3
        neg     d3
        add.b   d7,d6
        ror.l   d6,d6
        move.w  d6,d4
        asr.w   d0,d4
        ror.l   d6,d6
        move.w  d6,d5
        asr.w   d0,d5
        
        moveq   #0,d2
        
        move    a3,d1
.nono   

        movem.w d0/d1/D2/D3/d4/d5,(a2)
        add.w   #16,a2
                        ;x y z zvel xvel yvel 

        dbf     d7,.polop       
        bra.s   forward
bump
        lea     tex+256*10,a1
        lea     light,a2

        move.w  -2(a6),d0
        lea     -512*4(a6),a3   
        move    (a3,d0.w*4),d5
        add.w   #64*4,a3
        move    (a3,d0.w*4),d6
        add     #$8000,d6
        lsr     #1,d6
        moveq   #9,d1
        asr.w   d1,d5
        move.b  d5,d6
        add.w   d6,a2
        
        move    #170*256-1,d7
        move.l  a6,a0
.lop
        move.b  (a1)+,d0
        add.b   -255(a1),d0
        move.b  d0,d1
        sub.b   (a1),d0
        sub.b   255(a1),d1
        lsl.w   #8,d0
        move.b  d1,d0   
        
        move    d7,d1
        lsr     d1
        and.w   #$7f7f,d1
        add.w   d1,d0
        move.b  32(a2,d0.w),(a0)+
        dbf     d7,.lop         
forward
        bra     main
d

Code_End:       printv  Code_End-Code_Start

;; ******************** BSS area ********************

        section BSS_Area,bss

; declare BSS vars here.

                ds.b    65536
Sin1024:        ds.l    512
buffer:         ds.b    65536
tex:            ds.b    65536
light:          ds.b    65536
pts:            ds.b    65536
                ds.b    65536
                
;; ******************** Internal BSS area ********************

        section TempBuffer,bss

TempBuffer:     ds.b    320*256/2
Registers:      ds.l    15

        section Planes,bss_c

Planes1:        ds.l    320*256/32*8
Planes2:        ds.l    320*256/32*8

;; ******************** Screen setup ********************
