; Startup for the #amycoders 384 bytes demo compo by Blueberry/Efreet.

; QuickFixed by Harry "Piru" Sintonen 15th July 1998:
;
;  1) Didn't require KS V39 -> Crash on pre-V39 (at least pre-V37).
;  2) Didn't restore original task priority.
;  3) TAG_END was missing from ProcessParams taglist.
;  4) Improved interleaved test a bit.
;  5) It wasn't possible to compile intro with Devpac because use
;     of basereg and global\.local references.
;  6) Fixed loads of "Warning: trailing comma at end of DC directive"
;

	incdir	dh1:assembler/includes
	include	systemdefs.i

	opt	o+,w-

	output	dh1:512.exe

call	macro
	jsr	_LVO\1(a6)
	endm
	
	section	code,code

Startup:
	move.l	$4.w,a6
	lea.l	IntName(pc),a1
	moveq.l	#39,d0
	call	OpenLibrary
	move.l	d0,IntBase
	beq.w	.noint
	lea.l	GfxName(pc),a1
	moveq.l	#39,d0
	call	OpenLibrary
	move.l	d0,GfxBase
	beq.w	.nogfx
	lea.l	DosName(pc),a1
	moveq.l	#39,d0
	call	OpenLibrary
	move.l	d0,DosBase
	beq.w	.nodos

	; Open screen.
	move.l	IntBase(pc),a6
	suba.l	a0,a0
	lea.l	ScreenParams(pc),a1
	call	OpenScreenTagList
	move.l	d0,_Screen
	beq.b	.noscr
	; Ensure that the screen is interleaved.
	move.l	d0,a0
	move.l	sc_RastPort+rp_BitMap(a0),a1
	move.l	bm_Planes+4(a1),d1
	sub.l	bm_Planes(a1),d1
	lsl.l	#3,d1			; HS: *DEPTH
	cmp.w	bm_BytesPerRow(a1),d1
	bne.b	.notil			; HS: fix
	; Put BitMap1 into _Screen->ViewPort.RasInfo
	move.l	sc_ViewPort+vp_RasInfo(a0),a1
	move.l	#BitMap1,ri_BitMap(a1)

	; Set own priority to 0.
	move.l	$4.w,a6
	suba.l	a1,a1
	call	FindTask
	move.l	d0,a1
	moveq.l	#0,d0
	move.l	a1,-(sp)		; HS: store thistask
	call	SetTaskPri
	move.l	d0,-(sp)		; HS: store old pri!

	; Create VBlank process.
	move.l	DosBase(pc),a6
	move.l	#ProcessParams,d1
	call	CreateNewProc
	move.l	d0,Process
	beq.b	.nopro

	bsr.w	DoTheJob

.nopro:
	move.l	$4.w,a6			; HS: restore pri
	move.l	(sp)+,d0
	move.l	(sp)+,a1
	call	SetTaskPri

.notil:	move.l	IntBase(pc),a6
	move.l	_Screen(pc),a0
	call	CloseScreen
.noscr:	move.l	$4.w,a6
	move.l	DosBase(pc),a1
	call	CloseLibrary
.nodos:	move.l	GfxBase(pc),a1
	call	CloseLibrary
.nogfx:	move.l	IntBase(pc),a1
	call	CloseLibrary
.noint:	moveq.l	#0,d0
	rts

ScreenParams:
	dc.l	SA_Left,0		; HS: not really needed.
	dc.l	SA_Top,0		; HS: not really needed.
	dc.l	SA_Width,320
	dc.l	SA_Height,256
	dc.l	SA_Depth,8
	dc.l	SA_ShowTitle,0
	dc.l	SA_BitMap,BitMap1
	dc.l	SA_Quiet,1
	dc.l	SA_Type,CUSTOMSCREEN
	dc.l	SA_DisplayID,PAL_MONITOR_ID
	dc.l	SA_Interleaved,1	; HS: not really needed.
	dc.l	TAG_END

ProcessParams:
	dc.l	NP_Entry,VBlankProcess
	dc.l	NP_Name,ProcessName
	dc.l	NP_Priority,1
	dc.l	TAG_END			; HS: WAS MISSING!

BitMap1:
	dc.w	8*40,256,8,0
	dc.l	Planes1+0*40,Planes1+1*40,Planes1+2*40,Planes1+3*40
	dc.l	Planes1+4*40,Planes1+5*40,Planes1+6*40,Planes1+7*40

BitMap2:
	dc.w	8*40,256,8,0
	dc.l	Planes2+0*40,Planes2+1*40,Planes2+2*40,Planes2+3*40
	dc.l	Planes2+4*40,Planes2+5*40,Planes2+6*40,Planes2+7*40

IntBase:	dc.l	0
GfxBase:	dc.l	0
DosBase:	dc.l	0
_Screen:	dc.l	0
OldBitMap:	dc.l	0
Process:	dc.l	0
OldStack:	dc.l	0
ProcessState:	dc.w	0
C2P1x1State:	dc.w	0
C2P2x1State:	dc.w	0
C2PEdgeState:	dc.w	0

IntName:	dc.b	'intuition.library',0
GfxName:	dc.b	'graphics.library',0
DosName:	dc.b	'dos.library',0
ProcessName:	dc.b	'VBlank process',0
		even

;; ******************** Calling shell ********************

DoTheJob:
	move.l	a7,OldStack
;	move.w	#$000f,$dff096
	bsr.w	Init
	movem.l	d0-a6,Registers
	move.w	#1,ProcessState
.wait1:	cmp.w	#2,ProcessState	; Wait for VBlank process to begin.
	bne.b	.wait1
	bsr.w	Main

Exit:
;	move.w	#$000f,$dff096
	move.l	OldStack(pc),a7
	move.w	#3,ProcessState
.wait2:	cmp.w	#4,ProcessState	; Wait for VBlank process to end.
	bne.b	.wait2
	rts

VBlankProcess:
.loop1:	move.l	GfxBase(pc),a6
	call	WaitTOF
	tst.w	ProcessState(pc)
	beq.b	.loop1
	move.w	#2,ProcessState
	movem.l	Registers,d0-a6
.loop2:	bsr.w	VBlank
	movem.l	d0-d1/a0-a1/a6,-(a7)
	move.l	GfxBase(pc),a6
	call	WaitTOF
	movem.l	(a7)+,d0-d1/a0-a1/a6
	cmp.w	#3,ProcessState
	bne.b	.loop2
	move.w	#4,ProcessState
	rts

;; ******************** Internal routines ********************

TestMouse:
	; Exit if LMB pressed.
	btst.b	#6,$bfe001
	beq.b	Exit
	rts

GetScreen:
	move.l	_Screen(pc),a3
	move.l	sc_ViewPort+vp_RasInfo(a3),a3
	move.l	#BitMap1,a2
	add.l	#BitMap2,a2
	sub.l	ri_BitMap(a3),a2	; Other BitMap.
	move.l	bm_Planes(a2),a1
	; A1 = PlanePtr of Undisplayed BitMap
	; A2 = Undisplayed BitMap
	; A3 = _Screen->Viewport.RasInfo
	rts

DoubleBuffer:
	bsr.w	GetScreen
	move.l	a2,ri_BitMap(a3)	; Do the switch.
	move.l	GfxBase(pc),a6
	move.l	_Screen(pc),a0
	lea.l	sc_ViewPort(a0),a0
	jmp	(_LVOScrollVPort,a6)	; And display it.

ClearEdges:
	tst.w	C2PEdgeState
	beq.b	.ok
	bsr.w	GetScreen
	move.w	#256*8-1,d7
.loop:	clr.l	(a1)+
	lea.l	40-8(a1),a1
	clr.l	(a1)+
	dbf	d7,.loop
	clr.w	C2PEdgeState
.ok:	rts

	; *** Adjust this include path! ***
	include	C2P1x1x8.S
	include	C2P2x1x8.S

;; ******************** Callable routines ********************

Update128x128:
	; Update the screen in 2x2 resolution
	; using the supplied 128x128 linear chunky buffer.
	; The sides will get color 0.
	; Callable from Init and Main.
	; Input: A0 = Chunky buffer
	bsr.w	TestMouse
	movem.l	d0-a6,-(a7)
	bsr.w	ClearEdges
	tst.w	C2P2x1State(pc)
	blt.b	.ok
	move.w	#128,d0
	move.w	#128,d1
	moveq.l	#40,d2
	move.w	#8+15*40,d3
	bsr.w	C2P2x1x8_SetSizes
	move.w	#-1,C2P2x1State
	move.l	8*4(a7),a0
.ok:	bsr.w	GetScreen
	addq.l	#4,a1
	bsr.w	C2P2x1x8
	move.l	8*4(a7),a0
	bsr.w	GetScreen
	lea.l	8*40+4(a1),a1
	bsr.w	C2P2x1x8
	bsr.w	DoubleBuffer
	movem.l	(a7)+,d0-a6
	rts

Update160x128:
	; Update the screen in 2x2 resolution
	; using the supplied 160x128 linear chunky buffer.
	; Callable from Init and Main.
	; Input: A0 = Chunky buffer
	bsr.w	TestMouse
	movem.l	d0-a6,-(a7)
	move.w	#-1,C2PEdgeState
	tst.w	C2P2x1State(pc)
	bgt.b	.ok
	move.w	#160,d0
	move.w	#128,d1
	moveq.l	#40,d2
	move.w	#15*40,d3
	bsr.w	C2P2x1x8_SetSizes
	move.w	#1,C2P2x1State
	move.l	8*4(a7),a0
.ok:	bsr.w	GetScreen
	bsr.w	C2P2x1x8
	move.l	8*4(a7),a0
	bsr.w	GetScreen
	lea.l	8*40(a1),a1
	bsr.w	C2P2x1x8
	bsr.w	DoubleBuffer
	movem.l	(a7)+,d0-a6
	rts

Update256x256:
	; Update the screen in 1x1 resolution
	; using the supplied 256x256 linear chunky buffer.
	; The sides will get color 0.
	; Callable from Init and Main.
	; Input: A0 = Chunky buffer
	bsr.w	TestMouse
	movem.l	d0-a6,-(a7)
	bsr.w	ClearEdges
	tst.w	C2P1x1State(pc)
	blt.b	.ok
	move.w	#256,d0
	move.w	#256,d1
	moveq.l	#40,d2
	move.w	#8+7*40,d3
	bsr.w	C2P1x1x8_SetSizes
	move.w	#-1,C2P1x1State
	move.l	8*4(a7),a0
.ok:	bsr.w	GetScreen
	addq.l	#4,a1
	lea.l	TempBuffer,a2
	bsr.w	C2P1x1x8
	bsr.w	DoubleBuffer
	movem.l	(a7)+,d0-a6
	rts

Update320x256:
	; Update the screen in 1x1 resolution
	; using the supplied 320x256 linear chunky buffer.
	; Callable from Init and Main.
	; Input: A0 = Chunky buffer
	bsr.w	TestMouse
	movem.l	d0-a6,-(a7)
	move.w	#-1,C2PEdgeState
	tst.w	C2P1x1State(pc)
	bgt.b	.ok
	move.w	#320,d0
	move.w	#256,d1
	moveq.l	#40,d2
	move.w	#7*40,d3
	bsr.w	C2P1x1x8_SetSizes
	move.w	#1,C2P1x1State
	move.l	8*4(a7),a0
.ok:	bsr.w	GetScreen
	lea.l	TempBuffer,a2
	bsr.w	C2P1x1x8
	bsr.w	DoubleBuffer
	movem.l	(a7)+,d0-a6
	rts

CacheClear:
	; Clear caches so written SMC will be valid.
	; Callable from Init, VBlank and Main.
	movem.l	d0-d1/a0-a1/a6,-(a7)
	move.l	$4.w,a6
	call	CacheClearU
	movem.l	(a7)+,d0-d1/a0-a1/a6
	rts

SetPalette:
	; Set the screen palette to the one supplied.
	; Format is 256 longwords in $xxrrggbb.
	; The upper byte of each longword is ignored.
	; Callable from Init, VBlank and Main.
	; Input: A0 = Palette
	movem.l	d0-d2/a0-a2/a6,-(a7)
	lea.l	.data(pc),a1
	lea.l	4(a1),a2
	move.w	#256-1,d2
.loop:	move.w	(a0)+,d0
	move.b	d0,(a2)
	addq.l	#4,a2
	move.b	(a0)+,d0
	move.b	d0,(a2)
	addq.l	#4,a2
	move.b	(a0)+,d0
	move.b	d0,(a2)
	addq.l	#4,a2

	dbra	d2,.loop

	move.l	GfxBase(pc),a6
	move.l	_Screen(pc),a0
	lea.l	sc_ViewPort(a0),a0
	call	LoadRGB32
	movem.l	(a7)+,d0-d2/a0-a2/a6
	rts
.data:
	dc.w	256,0
	dcb.l	256*3
	dc.w	0
	
;; ********************************************************
;; ******************** Your code here ********************
;; ********************************************************

* Boing '98! An entry to the #amycoders 512 bytes compo.
* Written by Chris 'Platon42' Hodges (platon@cu-muc.de)
* Visit my Homepage: http://platon.home.pages.de
* Started on 22-Aug-98. Finished on 26-Aug-98.
*
* 060 version: 512 bytes.
* 030 version: 484 bytes.
*
* Feel free to try different settings!


	include	"exec/types.i"
	include	"hardware/custom.i"

_custom	equ	$DFF000

CPU_030		equ	0


	IFEQ	CPU_030
NumBoings	equ	16
LightSourcing	equ	1
SizeLighting	equ	1
Texture		equ	1
PersTexture	equ	1
SizeTexture	equ	1
DiaTexture	equ	1
BlurMode	equ	1
DeepRedPalette	equ	1
	ELSE
NumBoings	equ	8
LightSourcing	equ	1
SizeLighting	equ	0
Texture		equ	1
PersTexture	equ	1
SizeTexture	equ	0
DiaTexture	equ	0
BlurMode	equ	0
DeepRedPalette	equ	1
	ENDC

 STRUCTURE	BoingBall,0
	UWORD	BB_Rad
	UWORD	BB_RadSqr
 	WORD	BB_X
	WORD	BB_Y
	WORD	BB_SX
	WORD	BB_SY
	LABEL	BB_SizeOf

 STRUCTURE	myvars,0
	WORD	ST_LightX
	WORD	ST_LightY
	WORD	ST_HotLightX
	WORD	ST_HotLightY
	WORD	ST_VoidX
	WORD	ST_VoidY
	WORD	ST_TexOffset
	WORD	ST_AudioChannel
	STRUCT	ST_Boings,NumBoings*BB_SizeOf
	STRUCT	ST_PalBuffer,256*4
	STRUCT	ST_ChunkyBuffer,256*256
	LONG	ST_NullGap2
	LABEL	ST_SizeOf

;ST_LightX	equ	ST_Boings+BB_X
;ST_LightY	equ	ST_Boings+BB_Y


;	opt	w+

	cnop	0,16
	dc.b	'STRT'
Code_Start:

Init:	; Called once in the beginning.
	; Registers are undefined.
	lea	Var512,a5
	lea	ST_ChunkyBuffer(a5),a4
;	lea	ST_PalBuffer+256*4(a5),a3
	move.l	a4,a3
	moveq.l	#127,d6
	st	d1
.pallop
	IFNE	DeepRedPalette
;	move.w	d6,d2
;	lsr.w	#1,d2
;	move.b	d2,-(a3)
;	move.b	d2,-(a3)
	clr.w	-(a3)
	move.w	d1,-(a3)
	ELSE
	move.b	d6,-(a3)
	move.b	d6,-(a3)
	move.w	d1,-(a3)
	ENDC
	move.b	d1,-(a3)
	move.b	d1,-(a3)
	move.w	d1,-(a3)
	subq.w	#2,d1
	dbra	d6,.pallop
	move.l	a3,a0
	bsr	SetPalette

	move.l	#$80008000,ST_LightX(a5)
	move.w	d6,d0

	moveq.l	#NumBoings-1,d7
;	lea	ST_Boings+BB_SizeOf*NumBoings(a5),a3
.bbloop	lea	-BB_SizeOf(a3),a3
	eor.w	#$753a,d0
	move.w	d0,d1
	lsr.w	#8,d1
	lsr.w	#3,d1
	addq.w	#4,d1
	move.w	d1,BB_Rad(a3)
	move.w	d0,BB_Y(a3)
	rol.l	#5,d0
	add.w	d1,BB_Y-1(a3)
	asr.w	#6,d0
	move.w	d0,BB_SX(a3)
	rol.l	#7,d0
	add.l	d1,d0
	move.w	d0,BB_X(a3)
	lsr.w	#1,d0
	mulu	d1,d1
	move.w	d1,BB_RadSqr(a3)
	dbra	d7,.bbloop

	lea	_custom+aud,a6
	lea	BoingSnd,a2
	move.l	a2,a0
;	moveq.l	#-1,d6
;	lsr.w	#1,d6
.sndlop	;addq.w	#1,d0
;	ror.w	d0,d3
	and.w	#1,d3
	add.w	d3,d2
	and.w	#$F,d2
	move.b	.sine(pc,d2.w),d0
	ext.w	d0
	muls	d6,d0
	swap	d0
	move.b	d0,(a0)+
	move.w	d6,d3
	lsr.w	#8,d3
	lsr.w	#1,d3
	sub.w	d3,d6
	dbra	d7,.sndlop
	rts

.sine	dc.b	0,48,90,117,127,117,89,48
	dc.b	0,-48,-90,-117,-127,-117,-89,-48

VBlank:	
	IFEQ	PersTexture
	addq.w	#1,ST_TexOffset(a5)
	ELSE
	subq.w	#1,ST_TexOffset(a5)
	ENDC
	moveq.l	#NumBoings-1,d6

	move.l	a3,a1	
.reboun	move.w	BB_SY(a1),d0
	move.w	BB_Y(a1),d2
	add.w	d0,d2
	move.w	d2,d1
	add.w	BB_Rad+1(a1),d1
	bcc.s	.noreb
	neg.w	BB_SY(a1)
	subq.w	#8,d2

	move.w	#$0001,dmacon-aud(a6)
.waloop	dbra	d7,.waloop
	moveq.l	#127,d1
	move.l	a2,(a6)+		;ac_ptr
	move.w	d7,(a6)+		;ac_len
	move.w	BB_RadSqr(a1),(a6)
	add.w	d1,(a6)+		;ac_per
	move.w	d1,(a6)			;ac_vol
	subq.l	#8,a6
	move.w	#$8001,dmacon-aud(a6)

.noreb	move.w	d2,BB_Y(a1)
	addq.w	#2,BB_SY(a1)

.skip	move.w	BB_SX(a1),d0
	add.w	d0,BB_X(a1)
	lea	BB_SizeOf(a1),a1
	dbra	d6,.reboun
	rts

Main:
	move.l	a3,a1
	moveq.l	#NumBoings-1,d7
.bbloop	move.l	d7,-(sp)
	bsr.s	boingball
	move.l	(sp)+,d7
	lea	BB_SizeOf(a1),a1
	dbra	d7,.bbloop

	move.l	a4,a0
	bsr	Update256x256

	IFNE	BlurMode

	IFEQ	1
	moveq.l	#0,d0
	move.b	(a0),d2
	lsr.b	#1,d2
.loop	move.b	1(a0),d1
	lsr.b	#1,d1
	add.b	d1,d0
	and.b	#$FE,d0
	move.b	d0,(a0)+
	move.b	d2,d0
	move.b	d1,d2
	dbra	d7,.loop
	ELSE
	moveq.l	#0,d0
.loop	move.b	1(a0),d1
	lsr.b	#1,d1
	add.b	d1,d0
	and.b	#$FE,d0
	move.b	d0,(a0)+
	move.b	d1,d0
	dbra	d7,.loop

	ENDC
	ELSE
	lsr.w	#2,d7
;	move.w	#(256*256)/4-1,d7
.loop	clr.l	(a0)+
	dbra	d7,.loop
	ENDC
	bra	Main

boingball				;a1=struct *BoingBall

	IFNE	LightSourcing
	move.w	BB_Rad(a1),d2		;calculate hot spot of lighting
	moveq.l	#1,d3
	moveq.l	#16,d4
.2nd	move.w	BB_X(a1,d3.w*2),d0
	move.w	d0,d1
	asr.w	#8,d0
	move.w	d0,ST_VoidX(a5,d3.w*2)
	sub.w	ST_LightX(a5,d3.w*2),d1
	muls	d2,d1
	asr.l	d4,d1
	move.w	d1,ST_HotLightX(a5,d3.w*2)
	dbra	d3,.2nd

	move.w	d2,d7			;drawing loop
	ELSE
	moveq.l	#1,d3
.2nd	move.w	BB_X(a1,d3.w*2),d0
	asr.w	#8,d0
	move.w	d0,ST_VoidX(a5,d3.w*2)
	dbra	d3,.2nd
	move.w	BB_Rad(a1),d7	
	ENDC

.yloop	move.w	BB_Rad(a1),d6
	move.w	d7,d3
	mulu	d3,d3			;y*y
.xloop	move.w	d6,d5
	mulu	d5,d5			;x*x
	add.w	d3,d5			;d*d  = x*x+y*y
	sub.w	BB_RadSqr(a1),d5	;-dist = d*d-r*r
	bge.s	.nodot			;d*d >= r*r ?
	IFNE	PersTexture
;	neg.w	d5			;dist
	sub.w	BB_RadSqr(a1),d5
	ENDC

	bsr.s	.dot
	neg.w	d6
	bsr.s	.dot
	neg.w	d7
	bsr.s	.dot
	neg.w	d6
	bsr.s	.dot
	neg.w	d7
.nodot	dbra	d6,.xloop
	dbra	d7,.yloop
	rts
.dot
	IFNE	LightSourcing
	move.w	d6,d1			;calculate lighting
	add.w	ST_HotLightX(a5),d1
	move.w	d7,d2
	add.w	ST_HotLightY(a5),d2
	muls	d1,d1			;px*px
	muls	d2,d2			;py*py
	add.l	d1,d2			;dx*dx+dy*dy
	IFNE	SizeLighting
	lsl.l	#8,d2
	divu	BB_RadSqr(a1),d2
	ELSE
	lsr.l	#1,d2
	ENDC
	cmp.w	#$FF,d2
	ble.s	.noover
	st	d2
.noover
	ELSE
	moveq.l	#0,d2
	ENDC

	bclr	#0,d2

	IFNE	Texture

	move.w	d6,d0			;calculate 'texture'
	move.w	d7,d1

	IFNE	PersTexture
	lsl.w	#1,d0
	muls	BB_RadSqr(a1),d0	;p*r2
	divs	d5,d0			;(p*r2*2)/dist

	lsl.w	#1,d1
	muls	BB_RadSqr(a1),d1	;p*r2
	divs	d5,d1			;(p*r2*2)/dist
	ENDC

	IFNE	SizeTexture
	moveq.l	#0,d4
	ENDC

	IFNE	DiaTexture
	move.w	d0,d4
	add.w	d1,d4
	add.w	d1,d4
	add.w	ST_TexOffset(a5),d4	;(px+to)+(py+to)*2
	ELSE
	move.w	d1,d4
	add.w	d4,d4
	add.w	ST_TexOffset(a5),d4	;(py+to)*2
	ENDC

	IFNE	SizeTexture		;zoom texture
	IFEQ	PersTexture
	divu	BB_Rad(a1),d4
	ELSE
	ext.l	d4
	divs	BB_Rad(a1),d4
	ENDC
	ELSE
	lsr.w	#4,d4
	ENDC

	IFNE	DiaTexture
	add.w	d0,d0
	sub.w	d1,d0			;(px+to)*2-(py+to)
	add.w	ST_TexOffset(a5),d0
	ELSE
	add.w	d0,d0
	add.w	ST_TexOffset(a5),d0	;(px+to)*2
	ENDC

	IFNE	SizeTexture		;zoom texture
	IFEQ	PersTexture
	divu	BB_Rad(a1),d0
	ELSE
	ext.l	d0
	divs	BB_Rad(a1),d0
	ENDC
	ELSE
	lsr.w	#4,d0
	ENDC


	add.w	d0,d4
	and.w	#$1,d4
	moveq.l	#0,d0
	or.w	d4,d2

	ELSE
	moveq.l	#0,d0
	ENDC
	
	move.w	ST_VoidX(a5),d0
	move.w	ST_VoidY(a5),d1
	add.b	d6,d0
	and.w	#$00FF,d0
	add.b	d7,d1
	lsl.w	#8,d1
	not.b	d2
	or.w	d1,d0
	move.b	d2,(a4,d0.l)
	rts

Code_End:
	dc.b	'END!'
	dc.l	Code_End-Code_Start
	
;; ******************** BSS area ********************

	section	BSS_Area,bss

Var512	ds.b	ST_SizeOf

; declare BSS vars here. and only here

	section	BBS_AreaChip,bss_c
BoingSnd
	ds.b	128*1024

;; ******************** Internal BSS area ********************

	section	TempBuffer,bss

TempBuffer:	ds.b	320*256/2
Registers:	ds.l	15

	section	Planes,bss_c

Planes1:	ds.l	320*256/32*8
Planes2:	ds.l	320*256/32*8

;; ******************** Screen setup ********************
