; Startup for the #amycoders 384 bytes demo compo by Blueberry/Efreet.

; QuickFixed by Harry "Piru" Sintonen 15th July 1998:
;
;  1) Didn't require KS V39 -> Crash on pre-V39 (at least pre-V37).
;  2) Didn't restore original task priority.
;  3) TAG_END was missing from ProcessParams taglist.
;  4) Improved interleaved test a bit.
;  5) It wasn't possible to compile intro with Devpac because use
;     of basereg and global\.local references.
;  6) Fixed loads of "Warning: trailing comma at end of DC directive"
;

	incdir	dh1:s_aga12/384BytesCompo/
	include	systemdefs.i

call	macro
	jsr	_LVO\1(a6)
	endm
	
	section	code,code

Startup:
	move.l	$4.w,a6
	lea.l	IntName(pc),a1
	moveq.l	#39,d0
	call	OpenLibrary
	move.l	d0,IntBase
	beq.w	.noint
	lea.l	GfxName(pc),a1
	moveq.l	#39,d0
	call	OpenLibrary
	move.l	d0,GfxBase
	beq.w	.nogfx
	lea.l	DosName(pc),a1
	moveq.l	#39,d0
	call	OpenLibrary
	move.l	d0,DosBase
	beq.w	.nodos

	; Open screen.
	move.l	IntBase(pc),a6
	suba.l	a0,a0
	lea.l	ScreenParams(pc),a1
	call	OpenScreenTagList
	move.l	d0,_Screen
	beq.b	.noscr
	; Ensure that the screen is interleaved.
	move.l	d0,a0
	move.l	sc_RastPort+rp_BitMap(a0),a1
	move.l	bm_Planes+4(a1),d1
	sub.l	bm_Planes(a1),d1
	lsl.l	#3,d1			; HS: *DEPTH
	cmp.w	bm_BytesPerRow(a1),d1
	bne.b	.notil			; HS: fix
	; Put BitMap1 into _Screen->ViewPort.RasInfo
	move.l	sc_ViewPort+vp_RasInfo(a0),a1
	move.l	#BitMap1,ri_BitMap(a1)

	; Set own priority to 0.
	move.l	$4.w,a6
	suba.l	a1,a1
	call	FindTask
	move.l	d0,a1
	moveq.l	#0,d0
	move.l	a1,-(sp)		; HS: store thistask
	call	SetTaskPri
	move.l	d0,-(sp)		; HS: store old pri!

	; Create VBlank process.
	move.l	DosBase(pc),a6
	move.l	#ProcessParams,d1
	call	CreateNewProc
	move.l	d0,Process
	beq.b	.nopro

	bsr.w	DoTheJob

.nopro:
	move.l	$4.w,a6			; HS: restore pri
	move.l	(sp)+,d0
	move.l	(sp)+,a1
	call	SetTaskPri

.notil:	move.l	IntBase(pc),a6
	move.l	_Screen(pc),a0
	call	CloseScreen
.noscr:	move.l	$4.w,a6
	move.l	DosBase(pc),a1
	call	CloseLibrary
.nodos:	move.l	GfxBase(pc),a1
	call	CloseLibrary
.nogfx:	move.l	IntBase(pc),a1
	call	CloseLibrary
.noint:	moveq.l	#0,d0
	rts

ScreenParams:
	dc.l	SA_Left,0		; HS: not really needed.
	dc.l	SA_Top,0		; HS: not really needed.
	dc.l	SA_Width,320
	dc.l	SA_Height,256
	dc.l	SA_Depth,8
	dc.l	SA_ShowTitle,0
	dc.l	SA_BitMap,BitMap1
	dc.l	SA_Quiet,1
	dc.l	SA_Type,CUSTOMSCREEN
	dc.l	SA_DisplayID,PAL_MONITOR_ID
	dc.l	SA_Interleaved,1	; HS: not really needed.
	dc.l	TAG_END

ProcessParams:
	dc.l	NP_Entry,VBlankProcess
	dc.l	NP_Name,ProcessName
	dc.l	NP_Priority,1
	dc.l	TAG_END			; HS: WAS MISSING!

BitMap1:
	dc.w	8*40,256,8,0
	dc.l	Planes1+0*40,Planes1+1*40,Planes1+2*40,Planes1+3*40
	dc.l	Planes1+4*40,Planes1+5*40,Planes1+6*40,Planes1+7*40

BitMap2:
	dc.w	8*40,256,8,0
	dc.l	Planes2+0*40,Planes2+1*40,Planes2+2*40,Planes2+3*40
	dc.l	Planes2+4*40,Planes2+5*40,Planes2+6*40,Planes2+7*40

IntBase:	dc.l	0
GfxBase:	dc.l	0
DosBase:	dc.l	0
_Screen:	dc.l	0
OldBitMap:	dc.l	0
Process:	dc.l	0
OldStack:	dc.l	0
ProcessState:	dc.w	0
C2P1x1State:	dc.w	0
C2P2x1State:	dc.w	0
C2PEdgeState:	dc.w	0

IntName:	dc.b	'intuition.library',0
GfxName:	dc.b	'graphics.library',0
DosName:	dc.b	'dos.library',0
ProcessName:	dc.b	'VBlank process',0
		even

;; ******************** Calling shell ********************

DoTheJob:
	move.l	a7,OldStack
	move.w	#$000f,$dff096
	bsr.w	Init
	movem.l	d0-a6,Registers
	move.w	#1,ProcessState
.wait1:	cmp.w	#2,ProcessState	; Wait for VBlank process to begin.
	bne.b	.wait1
	bsr.w	Main

Exit:
	move.w	#$000f,$dff096
	move.l	OldStack(pc),a7
	move.w	#3,ProcessState
.wait2:	cmp.w	#4,ProcessState	; Wait for VBlank process to end.
	bne.b	.wait2
	rts

VBlankProcess:
.loop1:	move.l	GfxBase(pc),a6
	call	WaitTOF
	tst.w	ProcessState(pc)
	beq.b	.loop1
	move.w	#2,ProcessState
	movem.l	Registers,d0-a6
.loop2:	bsr.w	VBlank
	movem.l	d0-d1/a0-a1/a6,-(a7)
	move.l	GfxBase(pc),a6
	call	WaitTOF
	movem.l	(a7)+,d0-d1/a0-a1/a6
	cmp.w	#3,ProcessState
	bne.b	.loop2
	move.w	#4,ProcessState
	rts

;; ******************** Internal routines ********************

TestMouse:
	; Exit if LMB pressed.
	btst.b	#6,$bfe001
	beq.b	Exit
	rts

GetScreen:
	move.l	_Screen(pc),a3
	move.l	sc_ViewPort+vp_RasInfo(a3),a3
	move.l	#BitMap1,a2
	add.l	#BitMap2,a2
	sub.l	ri_BitMap(a3),a2	; Other BitMap.
	move.l	bm_Planes(a2),a1
	; A1 = PlanePtr of Undisplayed BitMap
	; A2 = Undisplayed BitMap
	; A3 = _Screen->Viewport.RasInfo
	rts

DoubleBuffer:
	bsr.w	GetScreen
	move.l	a2,ri_BitMap(a3)	; Do the switch.
	move.l	GfxBase(pc),a6
	move.l	_Screen(pc),a0
	lea.l	sc_ViewPort(a0),a0
	jmp	(_LVOScrollVPort,a6)	; And display it.

ClearEdges:
	tst.w	C2PEdgeState
	beq.b	.ok
	bsr.w	GetScreen
	move.w	#256*8-1,d7
.loop:	clr.l	(a1)+
	lea.l	40-8(a1),a1
	clr.l	(a1)+
	dbf	d7,.loop
	clr.w	C2PEdgeState
.ok:	rts

	; *** Adjust this include path! ***
	include	C2P1x1x8.S
	include	C2P2x1x8.S

;; ******************** Callable routines ********************

Update128x128:
	; Update the screen in 2x2 resolution
	; using the supplied 128x128 linear chunky buffer.
	; The sides will get color 0.
	; Callable from Init and Main.
	; Input: A0 = Chunky buffer
	bsr.w	TestMouse
	movem.l	d0-a6,-(a7)
	bsr.w	ClearEdges
	tst.w	C2P2x1State(pc)
	blt.b	.ok
	move.w	#128,d0
	move.w	#128,d1
	moveq.l	#40,d2
	move.w	#8+15*40,d3
	bsr.w	C2P2x1x8_SetSizes
	move.w	#-1,C2P2x1State
	move.l	8*4(a7),a0
.ok:	bsr.w	GetScreen
	addq.l	#4,a1
	bsr.w	C2P2x1x8
	move.l	8*4(a7),a0
	bsr.w	GetScreen
	lea.l	8*40+4(a1),a1
	bsr.w	C2P2x1x8
	bsr.w	DoubleBuffer
	movem.l	(a7)+,d0-a6
	rts

Update160x128:
	; Update the screen in 2x2 resolution
	; using the supplied 160x128 linear chunky buffer.
	; Callable from Init and Main.
	; Input: A0 = Chunky buffer
	bsr.w	TestMouse
	movem.l	d0-a6,-(a7)
	move.w	#-1,C2PEdgeState
	tst.w	C2P2x1State(pc)
	bgt.b	.ok
	move.w	#160,d0
	move.w	#128,d1
	moveq.l	#40,d2
	move.w	#15*40,d3
	bsr.w	C2P2x1x8_SetSizes
	move.w	#1,C2P2x1State
	move.l	8*4(a7),a0
.ok:	bsr.w	GetScreen
	bsr.w	C2P2x1x8
	move.l	8*4(a7),a0
	bsr.w	GetScreen
	lea.l	8*40(a1),a1
	bsr.w	C2P2x1x8
	bsr.w	DoubleBuffer
	movem.l	(a7)+,d0-a6
	rts

Update256x256:
	; Update the screen in 1x1 resolution
	; using the supplied 256x256 linear chunky buffer.
	; The sides will get color 0.
	; Callable from Init and Main.
	; Input: A0 = Chunky buffer
	bsr.w	TestMouse
	movem.l	d0-a6,-(a7)
	bsr.w	ClearEdges
	tst.w	C2P1x1State(pc)
	blt.b	.ok
	move.w	#256,d0
	move.w	#256,d1
	moveq.l	#40,d2
	move.w	#8+7*40,d3
	bsr.w	C2P1x1x8_SetSizes
	move.w	#-1,C2P1x1State
	move.l	8*4(a7),a0
.ok:	bsr.w	GetScreen
	addq.l	#4,a1
	lea.l	TempBuffer,a2
	bsr.w	C2P1x1x8
	bsr.w	DoubleBuffer
	movem.l	(a7)+,d0-a6
	rts

Update320x256:
	; Update the screen in 1x1 resolution
	; using the supplied 320x256 linear chunky buffer.
	; Callable from Init and Main.
	; Input: A0 = Chunky buffer
	bsr.w	TestMouse
	movem.l	d0-a6,-(a7)
	move.w	#-1,C2PEdgeState
	tst.w	C2P1x1State(pc)
	bgt.b	.ok
	move.w	#320,d0
	move.w	#256,d1
	moveq.l	#40,d2
	move.w	#7*40,d3
	bsr.w	C2P1x1x8_SetSizes
	move.w	#1,C2P1x1State
	move.l	8*4(a7),a0
.ok:	bsr.w	GetScreen
	lea.l	TempBuffer,a2
	bsr.w	C2P1x1x8
	bsr.w	DoubleBuffer
	movem.l	(a7)+,d0-a6
	rts

CacheClear:
	; Clear caches so written SMC will be valid.
	; Callable from Init, VBlank and Main.
	movem.l	d0-d1/a0-a1/a6,-(a7)
	move.l	$4.w,a6
	call	CacheClearU
	movem.l	(a7)+,d0-d1/a0-a1/a6
	rts

SetPalette:
	; Set the screen palette to the one supplied.
	; Format is 256 longwords in $xxrrggbb.
	; The upper byte of each longword is ignored.
	; Callable from Init, VBlank and Main.
	; Input: A0 = Palette
	movem.l	d0-d2/a0-a2/a6,-(a7)
	lea.l	.data(pc),a1
	lea.l	4(a1),a2
	move.w	#256,d2
.loop:	move.w	(a0)+,d0
	move.b	d0,(a2)
	addq.l	#4,a2
	move.b	(a0)+,d0
	move.b	d0,(a2)
	addq.l	#4,a2
	move.b	(a0)+,d0
	move.b	d0,(a2)
	addq.l	#4,a2
	subq.b	#1,d2
	bne.b	.loop

	move.l	GfxBase(pc),a6
	move.l	_Screen(pc),a0
	lea.l	sc_ViewPort(a0),a0
	call	LoadRGB32
	movem.l	(a7)+,d0-d2/a0-a2/a6
	rts
.data:
	dc.w	256,0
	dcb.l	256*3
	dc.w	0
	
;; ********************************************************
;; ******************** Your code here ********************
;; ********************************************************

*************************************************************
**			"No Time"
**
**	Contribution for the 512 bytes compo  r.a.y^nce
**
*************************************************************


rchnk		equr	a0
DT		equr	a5
TimeCounter	equr	a6

chunkyx		equ	128
chunkyy		equ	128
chunkymask	equ	chunkyx*chunkyy-1

sinsize	equ	128		;n E
sinamp	equ	31		;a

anzfont		equ	76
sizecharx	equ	8
sizechary	equ	8

sizechar	equ	sizecharx*sizechary
;sizefontx	equ	((anzfont+1)*sizecharx)+(chunkyx*2)
sizefontx	equ	1024+(chunkyx*2)
sizefont	equ	(sizefontx*sizechary)

Code_Start:
Init:
	lea	data,DT
**********************************************************

*****************************************************	
initsin
        lea     sin-data(DT),a1
        moveq   #0,d0
     	move.l	#($06487E*sinamp)/sinsize,d1
     	move.l	#(($277A78/sinsize)<<16)/sinsize,d2
        move.w  #2047,d4
si2.Loop
        move.l  d0,(a1)
        addq.l  #2,a1
        move.l  d2,d3
        muls.l  d0,d7:d3
        sub.l   d7,d1
        add.l   d1,d0
        dbra    d4,si2.Loop
initsine
*****************************************************
initpal
	move.l	a1,a0
	lea	1024(a1),a2
	moveq	#0,d5
	lsr.w	#8,d4
.loop
	move.w	d5,(a1)+
	move.w	d5,-(a2)
	addq.l	#1,d5
	dbra	d4,.loop
	move.w	d4,-(a2)
	bsr	SetPalette
initpale
*******************************************************
logocx		equ	12
logoc_		equ	8
logoy		equ	16
logox		equ	chunkyx ;(logocx+logoc_)*6
logosize	equ	logox*logoy+logox*2
offset		equ	(8)+128*4
initlogo:
	lea	chunky-data+offset(DT),a1
	move.l	#%10111100001001000100110000000000,d1
	moveq	#0,d3
	move.w	#$7f7f,a2
	moveq	#2,d7
.oloop
	moveq	#5,d6
	rol.l	#8,d1
	move.b	d1,d0
.iloop
	lea	12(a1),a3
	bpl.s	.skip
	moveq	#logocx/2-1,d5
.dloop
	move.w	a2,(a1,d5*2)
	move.w	d3,(a3)+
	dbra	d5,.dloop
.skip
	lea	logoc_+logocx(a1),a1
	rol.b	#1,d0
	dbra	d6,.iloop
	lea	(logox*8)-(6*(logocx+logoc_))(a1),a1
	dbra	d7,.oloop
	lea	-logox*23(a1),a1
	lea	(a1),a3
	moveq	#5,d7
	bsr.s	draw
	moveq	#3,d7
	lea	chunky-data+logocx+logox+offset(DT),a1
draw:
	move.l	#$7f7f7f7f,a2
.doloop
	moveq	#15,d6
.diloop
	move.l	a2,(a1)
	lea	logox(a1),a1
	dbra	d6,.diloop
	lea	-(logox*16-(logocx+logoc_))(a1),a1
	dbra	d7,.doloop
******************************************************
initfont
	lea	fontdata-data+128(DT),a4
	moveq	#0,d1		;bitoffset
	moveq	#9,d2		;bitsize
	moveq	#0,d5		;offset fnttab
	moveq	#-1,d4
	moveq	#anzfont-1,d7		;loop
abcloop
        bfextu (font,pc){d1:d2},d3
        ;dc.w    $e9fa,$3862,font-*      
        add.l	d2,d1
	moveq	#8,d6
charwloop
	btst.l	d6,d3
	beq.s	skips
	move.l	a4,a3
	move.w	(fnttab,pc,d6.l*2),d5
	bmi.s	drs
	add.l	d5,a3
	move.b	d4,-(a3)
	lea	sizefontx+1(a3),a3
	move.b	d4,-(a3)
	bra.s	skips
drs	neg.w	d5
	add.l	d5,a3
	move.l	d4,(a3)+
	move.b	d4,(a3)
skips	
	dbra	d6,charwloop
	addq.l	#sizecharx,a4
	dbra	d7,abcloop
initfonte
********************************************************
	lea	chunky-data(DT),rchnk
VBlank:	
	lea	(timer,pc),TimeCounter
	subq.w	#2,(TimeCounter)
	lea	cnt(pc),a4
	addq.w	#1,(a4)
	and.w	#1023,(a4)
	bsr.s	parts
	rts

sizey	equ	sizefontx

timer:	dc.w	$2000
fnttab:
	dc.w	-(6*sizey+1)
	dc.w	-(3*sizey+1)
	dc.w	-(1*sizey+1)
	dc.w	2*sizey+7
	dc.w	4*sizey+7
	dc.w	4*sizey+4
	dc.w	4*sizey+1
	dc.w	2*sizey+1
	dc.w	0*sizey+1
	even
efont

Main:	
	bsr.w	Update128x128
	move.w	(TimeCounter),d0
	bmi.s	VBlank		;ende
.loop
	cmp.w	(TimeCounter),d0
	beq.s	.loop
	bra.s	Main

cnt	dc.w	0

parts:
	lea	128*32(rchnk),a1
	lea	(a1),a2
	move.w	(a4),d5
	move.w	#254,d1
	and.w	d1,d5
	moveq	#71,d7
.loop
	moveq	#127,d6
.iloop
	tst.b	d5
	beq.s	.skip
	tst.b	(a2)
	beq.s	.skip
	move.b	d5,(a2)
.skip
	move.b	d5,(a1)+
	subq.l	#1,a2
	dbra	d6,.iloop
	lea	64(a2),a2
	addq	#8,d5
	dbra	d7,.loop
s
	move.w	(a4),d0
	lea	fontdata-data(DT),a3
	lea	(a3,d0),a3
	moveq	#-128,d3
	add.w	d0,d3
	;;;
	and.w	d1,d3
	
	moveq	#127,d1
	lea	128*64(rchnk),a2
	move.l	a2,a4
	move.l	d1,d6
.oloop
	move.l	a3,a1
	moveq	#sizechary-1,d7
.iloop
	move.b	(a1),d0
	beq.s	.skip
	move.b	d1,(a2)
.skip
	lea	sizefontx(a1),a1
	lea	chunkyx(a2),a2
	dbra	d7,.iloop
	move.w	d6,d0
	and.l	d1,d0
	add	d3,d0
	move.w	-128(DT,d0*2),d0
	asl.w	#7,d0
	addq.l	#1,a4
	lea	-1(a4,d0),a2
	addq.l	#1,a3
	dbra	d6,.oloop
	rts
font:
	dc.b	$6e,$37,$40,$01,$c1,$03,$f1,$9e,$02,$2f,$80,$0b,$6c,$f7
	dc.b	$e3,$74,$00,$c6,$6e,$b1,$00,$01,$ce,$e3,$3c,$00,$97,$0c
	dc.b	$13,$c0,$1d,$d5,$50,$71,$9e,$97,$00,$31,$5b,$af,$c6,$73
	dc.b	$74,$04,$c5,$6e,$96,$d9,$e0,$06,$9a,$a8,$00,$c4,$2f,$aa
	dc.b	$80,$49,$f6,$23,$3d,$9e,$1c,$4b,$80,$03,$8d,$d0,$01,$7d
	dc.b	$82,$c1,$00,$17,$df,$82,$04,$f9,$7d,$8c,$c4,$67,$97,$fb
	dc.b	$49,$70
fonte
Code_End:	
		printt	"Length of your code"
		printv	Code_End-Code_Start
		printt	"font:"
		printv	initfonte-initfont
		printv	fonte-font
		printt	"sin:"
		printv	initsine-initsin
		printt	"pal:"
		printv	initpale-initpal
;; ******************** BSS area ********************

	section	BSS_Area,bss
; declare BSS vars here. and only here

fontdata	ds.b	sizefont
sin
	ds.w    1
sinbuf
	ds.w    256
data:
cosbuf
	ds.w    1791
pal:	
	ds.l	256
logobuf:
	ds.b	logosize
chunky:	
	ds.b	256*256
;; ******************** Internal BSS area ********************

	section	TempBuffer,bss

TempBuffer:	ds.b	320*256/2
Registers:	ds.l	15

	section	Planes,bss_c

Planes1:	ds.l	320*256/32*8
Planes2:	ds.l	320*256/32*8

;; ******************** Screen setup ********************
